﻿#region Using directives
using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Web;
using System.Web.Hosting;
using System.Threading;
using System.Diagnostics;
using System.Runtime.Remoting.Lifetime;
#endregion

namespace HttpListenerLibrary
{
    internal class HttpListenerWrapper : MarshalByRefObject
    {
		#region 重构 MarshalByRefObject 成员
		/// <summary>
		/// 用来防止对象过期
		/// </summary>
		/// <returns> </returns>
		public override object InitializeLifetimeService()
		{
			ILease lease = (ILease)base.InitializeLifetimeService();
			if (lease.CurrentState == LeaseState.Initial)
			{
				lease.InitialLeaseTime = TimeSpan.Zero;
			}
			return lease;
		}
		#endregion

        private HttpListener _listener;
        private string _virtualDir;
        private string _physicalDir;

        public void Configure(string vdir, string pdir)
        {
            _virtualDir = vdir;
            _physicalDir = pdir;
            _listener = new HttpListener();
        }

		public void AddPrefix(string Prefix)
		{
			_listener.Prefixes.Add(Prefix);
		}

		public void RemovePrefix(string Prefix)
		{
			_listener.Prefixes.Remove(Prefix);
		}

        public void Start()
        {
            _listener.Start();
        }

        public void Stop()
        {
			//_listener.Abort();
            _listener.Stop();
        }

        public void ProcessRequest()
        {
			HttpListenerContext ctx = null;

			try
			{
				ctx = _listener.GetContext();
			}
			catch
			{
				try
				{
					ctx.Response.Close();
				}
				catch
				{
				}
				ctx = null;
			}

			if (ctx != null)
			{
				HttpListenerWorkerRequest workerRequest =
					new HttpListenerWorkerRequest(ctx, _virtualDir, _physicalDir);
				HttpRuntime.ProcessRequest(workerRequest);
			}
        }
    }
}