﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using HttpListenerLibrary;

#endregion

namespace SampleWinAppHost
{
    partial class Form1 : Form
    {
        HttpListenerController _controller = null;
        
        string vdir = "/";
		string pdir = System.IO.Path.GetFullPath(System.IO.Path.Combine(Environment.CurrentDirectory, ".."));

        public Form1()
        {
            InitializeComponent();
        }

		private void Form1_Load(object sender, EventArgs e)
		{
			_controller = new HttpListenerController(vdir, pdir);
			foreach (string prefix in lbPrefix.Items)
			{
				_controller.AddPrefix(prefix);
			}
		}

        private void bStop_Click(object sender, EventArgs e)
        {
             _controller.Stop();
			 bStart.Enabled = true;
			 bStop.Enabled = false;
        }

		private void bStart_Click(object sender, EventArgs e)
		{
			_controller.Start();
			bStart.Enabled = false;
			bStop.Enabled = true;
		}

		private void bAddPrefix_Click(object sender, EventArgs e)
		{
			_controller.AddPrefix(tbPrefix.Text);
			lbPrefix.Items.Add(tbPrefix.Text);
		}

		private void bRemovePrefix_Click(object sender, EventArgs e)
		{
			_controller.RemovePrefix(lbPrefix.Text);
			lbPrefix.Items.RemoveAt(lbPrefix.SelectedIndex);
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (_controller.IsAlive)
			{
				e.Cancel = true;
				MessageBox.Show("必须先停止服务器才能退出程序。", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		private void lbPrefix_SelectedIndexChanged(object sender, EventArgs e)
		{
			tbPrefix.Text = lbPrefix.Text;
		}
    }
}